package com.gangstar;

import android.opengl.GLSurfaceView.Renderer;


import java.util.ArrayList;
import java.util.Date;
import java.util.Random;

import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.opengles.GL10;


import android.opengl.GLU;
import android.opengl.GLSurfaceView.Renderer;


import android.app.Activity;
import android.content.Context;
import android.os.Bundle;

public class BattleManager extends GangStarBattleManager implements Renderer {
	
	private int FieldX = 20;
	private int FieldY = 20;
	
	private int reds;
	private int blues;
	private int redsAlive;
	private int bluesAlive;
	ArrayList<Soldier> redSoldiers = new ArrayList<Soldier>();
	ArrayList<Soldier> blueSoldiers = new ArrayList<Soldier>();
	GangStarBattleManager parent;
	
	/** The Activity Context ( NEW ) */
	private Context context;
	
	private boolean virgin= true;
	private boolean shooting = false;
	private boolean starting_shooting = false;

    Random randomGenerator = new Random();
    Bullet bullet = new Bullet();
	
	/** Cube instance */
	private Grid grid;
	
	
	public BattleManager(int r, int b, GangStarBattleManager obj, Context temp) {
		this.context = temp;
		// TODO Auto-generated constructor stub
		parent = obj;
		reds = r;
		blues = b;
		redsAlive = reds;
		bluesAlive = blues;
		grid = new Grid();

    	
    	for (int i= 0; i < reds; i++) {
    		Soldier soldier = new Soldier();
    		redSoldiers.add(soldier);
    	}
    	for (int i= 0; i < blues; i++) {
    		Soldier soldier = new Soldier();
    		blueSoldiers.add(soldier);
    		
    	}
    	for (int i= 0; i < reds; i++) {
    		redSoldiers.get(i).SetSide('r');
    	}
    	for (int i= 0; i < blues; i++) {
    		blueSoldiers.get(i).SetSide('b');
    	}
    	
    	/**
    	 * Place soldiers, give them their coordinates!
    	 */
    	//space between soldiers 
    	//width / amount of soldiers+1
    	float space;
    	float randomInt;

    	for (int i = 0; i < redSoldiers.size(); i++) {
    		randomInt = randomGenerator.nextFloat()*2;
    		space = FieldX / (redSoldiers.size() + 1);
    		redSoldiers.get(i).SetPosX(space * (i+1) - FieldX/2);
    		redSoldiers.get(i).SetPosY(FieldY/2  - randomInt- 1f);

    	}
    	
    	for (int i = 0; i < blueSoldiers.size(); i++) {
    		randomInt = randomGenerator.nextFloat()*2;
    		space = FieldX / (blueSoldiers.size() + 1);
    		blueSoldiers.get(i).SetPosX(space * (i+2) - FieldX/2);
    		blueSoldiers.get(i).SetPosY(-FieldY/2 +randomInt +0.5f);
    		

    		
    	}
	}
	
	public void MakeTurn() {
		
		int shooter;
		int target;
		
		switch (randomGenerator.nextInt(2))
		{
		
		case 0:	//reds
			
			shooter = randomGenerator.nextInt(redSoldiers.size());
			target = randomGenerator.nextInt(blueSoldiers.size());
			
			bullet.SetShooterX(redSoldiers.get(shooter).GetPosX());
			bullet.SetShooterY(redSoldiers.get(shooter).GetPosY());
			bullet.SetTargetX(blueSoldiers.get(target).GetPosX());
			bullet.SetTargetY(blueSoldiers.get(target).GetPosY());
			
			
			blueSoldiers.get(target).SetHealth(blueSoldiers.get(target).GetHealth() -
												redSoldiers.get(shooter).GetPower());
			//blueSoldiers.remove(target);
			shooting = true;
			
			
			break;
		case 1:	//blues
			shooter = randomGenerator.nextInt(blueSoldiers.size());
			target = randomGenerator.nextInt(redSoldiers.size());
			
			bullet.SetShooterX(blueSoldiers.get(shooter).GetPosX());
			bullet.SetShooterY(blueSoldiers.get(shooter).GetPosY());
			bullet.SetTargetX(redSoldiers.get(target).GetPosX());
			bullet.SetTargetY(redSoldiers.get(target).GetPosY());
			
			redSoldiers.get(target).SetHealth(redSoldiers.get(target).GetHealth() -
					blueSoldiers.get(shooter).GetPower());
			
			shooting = true;
			//redSoldiers.remove(target);
			
			
			break;
		default:
				break;
				
		}
	}
	
	public void SimulateBattle(GL10 gl) {
		
		if (!virgin)
		{
			for (int i = 0; i < redSoldiers.size(); i++)
			{
				if (redSoldiers.get(i).GetHealth() < 1)
				{
					redSoldiers.remove(i);
				}
			}
			for (int i = 0; i < blueSoldiers.size(); i++)
			{
				if (blueSoldiers.get(i).GetHealth() < 1)
				{
					blueSoldiers.remove(i);
				}
			}
			
			if ((redSoldiers.size() > 0) && (blueSoldiers.size() > 0))
			{ 
				delay();
				MakeTurn();
				
			}
			else
			{	
				if (blueSoldiers.size() == 0) {
					PlayerSingleton.getInstance().setAttackerWon();
					PlayerSingleton.getInstance().setTroopsLeft(redSoldiers.size());
				}
				
				PlayerSingleton.getInstance().setTroopsLeft(blueSoldiers.size());
	
				delay();
				
				parent.finish();
			}
		}
		else
			virgin = false;
			
	}
	


	public int GetRedsAlive() {
		return redsAlive;
	}
	
	public int GetBluesAlive() {
		return bluesAlive;
	}

	public void onSurfaceCreated(GL10 gl, EGLConfig config) {		
		//Load the texture for the cube once during Surface creation
		grid.loadGLTexture(gl, this.context);
		bullet.loadGLTexture(gl, this.context);
		for (int i = 0; i < redSoldiers.size(); i++)
			redSoldiers.get(i).loadGLTexture(gl, context);
		for (int i = 0; i < blueSoldiers.size(); i++)
			blueSoldiers.get(i).loadGLTexture(gl, context);
		
		
		gl.glEnable(GL10.GL_TEXTURE_2D);			//Enable Texture Mapping ( NEW )
		gl.glShadeModel(GL10.GL_SMOOTH); 			//Enable Smooth Shading
		gl.glClearColor(0.0f, 0.0f, 0.0f, 0.5f); 	//Black Background
		gl.glClearDepthf(1.0f); 					//Depth Buffer Setup
		gl.glEnable(GL10.GL_DEPTH_TEST); 			//Enables Depth Testing
		gl.glDepthFunc(GL10.GL_LEQUAL); 			//The Type Of Depth Testing To Do
		
		//Really Nice Perspective Calculations
		gl.glHint(GL10.GL_PERSPECTIVE_CORRECTION_HINT, GL10.GL_POLYGON_SMOOTH_HINT);
		//gl.glHint(GL10.GL_PERSPECTIVE_CORRECTION_HINT, GL10.GL_NICEST); 
	}

	/**
	 * Here we do our drawing
	 */
	public void onDrawFrame(GL10 gl) {
		//Clear Screen And Depth Buffer
		gl.glClear(GL10.GL_COLOR_BUFFER_BIT | GL10.GL_DEPTH_BUFFER_BIT);	
		gl.glLoadIdentity();					//Reset The Current Modelview Matrix
		

		grid.draw(gl, FieldX/2, FieldY/2);							//Draw the Grid
		//grid.draw(gl);							//Draw the Grid
		

		
		if (redSoldiers.size() > 0)
		{
			for (int i= 0; i < redSoldiers.size(); i++) 
				redSoldiers.get(i).draw(gl);
		}
		if (blueSoldiers.size() > 0)
		{
			for (int i= 0; i < blueSoldiers.size(); i++) 
				blueSoldiers.get(i).draw(gl);
		}

		
		if (shooting) {
			
			shooting = bullet.draw(gl);

		}
		else if (!shooting) {
			//delay();
			SimulateBattle(gl);
		}

		
		
		gl.glLoadIdentity();
	}
	

	private void delay() {
		long last_millis = System.currentTimeMillis();
		long millis = last_millis;
		
		while (millis - last_millis < 50)
			millis = System.currentTimeMillis();
		
	}

	/**
	 * If the surface changes, reset the view
	 */
	public void onSurfaceChanged(GL10 gl, int width, int height) {
		if(height == 0) { 						//Prevent A Divide By Zero By
			height = 1; 						//Making Height Equal One
		}

		gl.glViewport(0, 0, width, height); 	//Reset The Current Viewport
		gl.glMatrixMode(GL10.GL_PROJECTION); 	//Select The Projection Matrix
		gl.glLoadIdentity(); 					//Reset The Projection Matrix

		//Calculate The Aspect Ratio Of The Window
		GLU.gluPerspective(gl, 45.0f, (float)width / (float)height, 0.1f, 100.0f);
		GLU.gluLookAt(gl, 0, 0, 34, 0, 0, 0, 0, 1, 0);

		gl.glMatrixMode(GL10.GL_MODELVIEW); 	//Select The Modelview Matrix
		gl.glLoadIdentity(); 					//Reset The Modelview Matrix
	}

	
}
