package com.gangstar;

import java.util.ArrayList;
import java.util.List;

import com.gangstar.R;

 
import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;
import com.google.android.maps.OverlayItem;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Point;
import android.graphics.RectF;
import android.graphics.drawable.Drawable;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.view.MotionEvent;
import android.view.View;
import android.widget.Button;
import android.widget.Toast;

 
public class MapsActivity extends MapActivity 
{    
    MapView mapView; 
    MapController mc;
    GeoPoint p;
    LocationManager lm;
    LocationListener locationListener;
    PlayerSingleton myPlayer = PlayerSingleton.getInstance();
    ArrayList<Area>areas = new ArrayList<Area>();
    ArrayList<Gangster>mobsters = new ArrayList<Gangster>();
    BlueFamily blueFamily = new BlueFamily();
    RedFamily redFamily = new RedFamily();
    
    class MapOverlay extends com.google.android.maps.Overlay
    {
        @Override
        public boolean draw(Canvas canvas, MapView mapView, 
        boolean shadow, long when) 
        {
            super.draw(canvas, mapView, shadow);                   
 
            //---translate the GeoPoint to screen pixels---
            Point screenPts = new Point();
            p = getPoint();
            myPlayer.setMyLocation(p);
            mapView.getProjection().toPixels(p, screenPts);
 
            //---add the marker---
            Bitmap bmp = BitmapFactory.decodeResource(
                getResources(), R.drawable.location);            
            canvas.drawBitmap(bmp, screenPts.x, screenPts.y-25, null);         
            return true;
        }
     /*   public boolean onTouchEvent(MotionEvent event, MapView mapView) 
        {   
            //---when user lifts his finger---
            if (event.getAction() == 1) {                
                GeoPoint p = mapView.getProjection().fromPixels(
                    (int) event.getX(),
                    (int) event.getY());
                    Toast.makeText(getBaseContext(), 
                        p.getLatitudeE6() / 1E6 + "," + 
                        p.getLongitudeE6() /1E6 , 
                        Toast.LENGTH_SHORT).show();
                    
            }                            
            return false;
        }   */
    } 
 
    

    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) 
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        
        Button next = (Button) findViewById(R.id.StatsButton);
        next.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
				 AlertDialog.Builder dialog2 = new AlertDialog.Builder(view.getContext());
					dialog2.setTitle("My Status");
					dialog2.setMessage(
							"Name: " + myPlayer.getPlayer().getName() +
							" Family: " + "Blue Family" +"\n" +
							"Goons: " + myPlayer.getPlayer().getGoons() + 
							" Money: " + myPlayer.getPlayer().getMoney() + "\n" +
							"Areas: " + myPlayer.getPlayer().getAreas().size() +
							" Revenue: " + myPlayer.getPlayer().getRevenues() + "\n" +
							"Current Weapon: " + myPlayer.getPlayer().getWeapon().getWeaponName());
					
					dialog2.setPositiveButton("Back", null);
					dialog2.show();
            }

        });
        
        
        
        
        lm = (LocationManager) 
        getSystemService(Context.LOCATION_SERVICE);    
    
        locationListener = new MyLocationListener();
    
        lm.requestLocationUpdates(
        LocationManager.GPS_PROVIDER, 
        0, 
        0, 
        locationListener);
 
        mapView = (MapView) findViewById(R.id.mapView);
        mapView.setBuiltInZoomControls(true);
 
        mc = mapView.getController();
        String coordinates[] = {"61.065734", "28.093766"};
        double lat = Double.parseDouble(coordinates[0]);
        double lng = Double.parseDouble(coordinates[1]);
 
        p = new GeoPoint(
            (int) (lat * 1E6), 
            (int) (lng * 1E6));
 
        mc.animateTo(p);
        mc.setZoom(17); 
        mapView.invalidate();
        
        //http://developer.android.com/intl/de/resources/tutorials/views/hello-mapview.html
        //http://code.google.com/intl/fi-FI/apis/maps/documentation/overlays.html#Drawing_Polylines
        //http://mobiforge.com/developing/story/using-google-maps-android
        
        // Add current location marker
        MapOverlay mapOverlay = new MapOverlay();
        List<Overlay> listOfOverlays = mapView.getOverlays();
    	

        // Create all the gangsters here
        //
        createGangsters();
        
        // Create the Points of interest here
        //
        createAreas();

        // Clear the list of overlays just to be sure
        // and then add the points of interested to the map
        //
        listOfOverlays.clear();
        listOfOverlays.add(mapOverlay);        
        listOfOverlays.add(drawAreas());
        
        mapView.invalidate();

    }
    
    private GangstarItemizedOverlay drawAreas() {
    	
        // Create the drawable item by pointing out the file
        Drawable drawable = this.getResources().getDrawable(R.drawable.dynamite);
        
        // Then create a new overlay and pass the drawable to it
        GangstarItemizedOverlay itemizedOverlay = new GangstarItemizedOverlay(drawable, this);


        for (Area place : areas) {
        	itemizedOverlay.addOverlay(createOverlayItem(place));
        }
		
        return itemizedOverlay;
	}

	private void createGangsters() {
		Gangster johannes = new Gangster("Johannes", blueFamily);
		Gangster rostislav = new Gangster("Rostislav", redFamily);
		Gangster janne = new Gangster("Janne", redFamily);
		Gangster luigi = new Gangster("Luigi Don Corleone", blueFamily);
		
		mobsters.add(johannes);
		mobsters.add(rostislav);
		mobsters.add(janne);
		mobsters.add(luigi);

		myPlayer.setPlayer(luigi);		
		luigi.addGoons(10);
	}

	/**
     * This function is used to create all the areas to the map
     * @author Japskua
     * 
     */
    private void createAreas() {
    	
    	Area area1 = new Area(
    			61.06269,
    			28.095613,
    			mobsters.get(0),
    			"Bad Hoods",
    			500,
    			8);
    	
    	Area area2 = new Area(
    			61.064175,
    			28.094818,
    			//mobsters.get(1),
    			mobsters.get(1),
    			"University",
    			1000,
    			10);
    	
    	Area area3 = new Area(
    			61.058578,
    			28.104956,
    			mobsters.get(0),
    			"The Beach",
    			400,
    			3);

    	Area area4 = new Area(
    			61.050499,
    			28.109879,
    			mobsters.get(2),
    			"Colosseum",
    			1500,
    			12);
    	
    	Area area5 = new Area(
    			61.051849,
    			28.104222,
    			mobsters.get(2),
    			"Shopping Mall",
    			2800,
    			20);
    	
    	Area area6 = new Area(
    			61.056169,
    			28.096346,
    			mobsters.get(1),
    			"Gangstah Alley",
    			0,
    			50);
    	
    	Area area7 = new Area(
    			61.065846,
    			28.108962,
    			mobsters.get(0),
    			"Pimp's Mansion",
    			10000,
    			38);
    	
        areas.add(area1);
        areas.add(area2);
        areas.add(area3);
        areas.add(area4);
        areas.add(area5);
        areas.add(area6);
        areas.add(area7);
		
	}

	/**
     * This function is used to create an OverlayItem that is created
     * based on the areas existing on the map
     * @author Japskua
     * @param area The Area object that is passed as the creator
     * @return an OverlayItem
     */
    public GangstarOverlayItem createOverlayItem(Area area) {
        GangstarOverlayItem overlayItem = new GangstarOverlayItem(
        		area.getPoint(),
        		area.getTopic(),
        		area.getContent(),
        		area);
    	return overlayItem;
    }

 
    @Override
    protected boolean isRouteDisplayed() {
        // TODO Auto-generated method stub
        return false;
    }
    /**
     * This is used to set the current location of the user
     * as an GeoPoint
     * @author Japskua
     * @param point
     */
    // set the own GeoPoint
    public void setPoint(GeoPoint point) {
    	this.p = point;
    }
    /**
     * This is used to get the current location of the user
     * @author Japskua
     * @return User location as a GeoPoint
     */
    public GeoPoint getPoint() {
    	return this.p;
    }
    
    private class MyLocationListener implements LocationListener 
    {
        @Override
        public void onLocationChanged(Location loc) {
            if (loc != null) {                
               /* Toast.makeText(getBaseContext(), 
                    "Location changed : Lat: " + loc.getLatitude() + 
                    " Lng: " + loc.getLongitude(), 
                    Toast.LENGTH_SHORT).show(); */
                
                GeoPoint p = new GeoPoint(
                        (int) (loc.getLatitude() * 1E6), 
                        (int) (loc.getLongitude() * 1E6));
                
                setPoint(p);
                mc.animateTo(p);
                mc.setZoom(16);           
                
                mapView.invalidate();
                
            }
        }

        @Override
        public void onProviderDisabled(String provider) {
            // TODO Auto-generated method stub
        }

        @Override
        public void onProviderEnabled(String provider) {
            // TODO Auto-generated method stub
        }

        @Override
        public void onStatusChanged(String provider, int status, 
            Bundle extras) {
            // TODO Auto-generated method stub
        }
    }    
}