/**
 *  The interface that all weapons should implement.
 *  It currently only gets the damage the weapon in question
 *  can deal out.
 * @author Japskua
 * @return Should return the damage the weapon does
 * 
 *
 */

package com.gangstar;

/**
 * 
 * @author Japskua
 * @version 1.0
 * The interface for all weapons. All weapons must
 * implement the getWeaponDamage() method so that 
 * they can be called later to know the amount of damage
 * it deals out.
 */
public interface Weapon {

	/**
	 * 
	 * @return returns the damage dealt as an integer
	 */
	public int getWeaponDamage();
	public String getWeaponName();
	
};

